﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.RiskAssessment
<script src="~/Script/Master/Layout.js"></script>
<style>
    .overflow-x-auto {
        overflow-x: auto;
    }

        .overflow-x-auto table {
            width: 1500px;
            max-width: inherit;
        }

    .modal-content {
        width: 538px;
    }

    #Observation {
        height: 100px !important;
        width: 100% !important;
    }
</style>
<section>
    <div class="right_section">
        @Html.HiddenFor(x => x.OrgId)
        @Html.HiddenFor(x => x.CategoryId)
        @Html.HiddenFor(x => x.QuestionnaireID)
        @Html.HiddenFor(x => x.CategoryName)
        <div class="pb-2 mt-3 mb-2 border-bottom box_title pl-4">
            Risk Assessment Report for @Model.CategoryName
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="AssessmentReport" asp-controller="RiskAssessment" asp-area="ApplicationManagement" asp-route-orgId="@Model.OrgId" asp-route-CategoryId="@Model.CategoryId" asp-route-QuestionnaireID="@Model.QuestionnaireID" asp-route-EnablerName="@Model.CategoryName">Back to Menu</a>
        </div>
        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div class="assign_box active_block fade in">
                        <div class="table_control overflow-x-auto">
                            <table id="tblRiskTreatment" class="table table-bordered table-hover">
                                <thead>
                                    <tr>
                                        <th>S.No.</th>
                                        <th>Control Name</th>
                                        <th>Control ID</th>
                                        <th>Control Rating</th>
                                        <th>Observation</th>
                                        <th>Recommendation</th>
                                        <th>Risk Owner</th>
                                        <th>Management Decision</th>
                                        <th>Justification</th>
                                        <th>Action Plan</th>
                                        <th>Responsibility</th>
                                        <th>Target closure Date</th>
                                        <th>Status</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @{
                                        var i = 0;
                                    }
                                    @foreach (var item in Model.ControlAssesmentControlList)
                                    {
                                        i += 1;
                                        string obs = item.Observation.Length > 20 ? item.Observation.Substring(0, 20) : item.Observation;
                                        string rec = item.Recommendation.Length > 20 ? item.Recommendation.Substring(0, 20) : item.Recommendation;
                                        <tr>
                                            <td><input type="hidden" value="@item.ICDID" />@i</td>
                                            <td>@item.ControlName</td>
                                            <td>@item.ControlId</td>
                                            <td><input type="number" class="form-control text-center" value="@item.Rating" disabled /></td>
                                            <td>@obs@(obs.Length >= 20 ? Html.Raw("<a href='#' onclick='fn_openPopup(`"+item.Observation+"`,0)'>...view more</a>") : "")</td>
                                            <td>@rec@(rec.Length >= 20 ? Html.Raw("<a href='#' onclick='fn_openPopup(`" + item.Recommendation + "`,1)' >...view more</a>") : "")</td>
                                            <td style="width:8%"><input type="text" value="@item.RiskOwner" class="form-control" /></td>
                                            <td style="width:8%">
                                                <select class='form-control m_no clsDecision' asp-for="@item.Decision" asp-items="@Model.ddlDecision"><option>--Select--</option></select>
                                            </td>
                                            <td style="width:8%"><input type="text" value="@item.Justification" class="form-control" /></td>
                                            <td style="width:8%"><input type="text" value="@item.ActionPlan" class="form-control" /></td>
                                            <td style="width:8%"><input type="text" value="@item.Responsibility" class="form-control" /></td>
                                            <td style="width:8%"><input type="text" value="@item.TargetclosureDate" class="form-control TargetClouserDate" /></td>
                                            <td style="width:8%">
                                                <select class='form-control m_no clsStatus' asp-for="@item.Status" asp-items="@Model.ddlStatus"><option>--Select--</option></select>
                                            </td>
                                        </tr>
                                    }
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="row" style="padding-top:10px">
                        <div class="col-md-12 col-sm-12 col-xs-12">
                            <div class="back_btn">
                                <div class="back_btn_in">
                                    <input type="submit" id="btnsubmit" name="Submit" value="Submit" onclick="PrepareToSubmit()">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<div class="modal fade" id="ObservationTextBox" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered modal-lg " role="document">
        <div class="modal-content">
            <div class="pb-2 mt-4 mb-2 border-bottom box_title pl-4" id="modaltext"></div>
            <div class="modal-body">
                <div class="row" style=" margin-bottom: 10px;">
                    <div class="col-12">
                        @Html.TextAreaFor(m => m.Observation, new { @class = "form-control m_no", disabled = "disabled" })
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <a class="btn btn-danger" data-dismiss="modal" href="#ObservationTextBox">OK</a>

            </div>
        </div>
    </div>
</div>
<script>
    $(document).ready(function () {
        debugger
        $(".TargetClouserDate").datepicker({
            dateFormat: 'dd/mm/yy',
            autoclose: true,
        });
        $('#tblRiskTreatment tbody tr').each(function (i, tr) {
            var value = $(tr).find("td:nth-child(4) input[type=number]").val();
            console.log(value);
            var backgroundColor = (value == 1 ? "rgb(190 26 26)" : value == 2 ? "#ffcdaa" : value == 3 ? "#ffbb3d" : value == 4 ? "rgb(195 246 195)" : value == 5 ? "rgb(93 178 93)" : "white");
            var TextColor = (value == 1 ? "white" : value == 2 ? "black" : value == 3 ? "black" : value == 4 ? "black" : value == 5 ? "white" : "black")
            $(tr).find("td:nth-child(4) input[type=number]").css({ "background-color": backgroundColor });
            $(tr).find("td:nth-child(4) input[type=number]").css({ "color": TextColor });
        })
    })
    function PrepareToSubmit() {
        var Array = [];
        $('#tblRiskTreatment tbody tr').each(function (i, tr) {
            Array[i] = {
                ICDID: $(tr).find("td:nth-child(1) input[type=hidden]").val(),
                ControlName: $(tr).find("td:nth-child(2)").text(),
                ControlId: $(tr).find("td:nth-child(3)").text(),
                Rating: $(tr).find("td:nth-child(4) input[type=number]").val(),
                Observation: $(tr).find("td:nth-child(5)").text(),
                Recommendation: $(tr).find("td:nth-child(6)").text(),
                RiskOwner: $(tr).find("td:nth-child(7) input[type=text]").val(),
                ManagementDecision: ($(tr).find("td:nth-child(8) option:Selected").val() == "--Select--" ? 0 : $(tr).find("td:nth-child(8) option:Selected").val()),
                Justification: $(tr).find("td:nth-child(9) input[type=text]").val(),
                ActionPlan: $(tr).find("td:nth-child(10) input[type=text]").val(),
                Responsibility: $(tr).find("td:nth-child(11) input[type=text]").val(),
                TargetclosureDate: $(tr).find("td:nth-child(12) input[type=text]").val(),
                Status: ($(tr).find("td:nth-child(13) option:Selected").val() == "--Select--" ? 0 : $(tr).find("td:nth-child(13) option:Selected").val()),
            }
        })
        var model = {
            OrgId: $("#OrgId").val(),
            QuestionnaireID: $("#QuestionnaireID").val(),
            xmlRiskTreatMent: JSON.stringify(Array)
        }
        $.post('/ApplicationManagement/RiskAssessment/SaveUpdateRiskTreatmentPlan', { model: model }, function (res) {
            if (res.isSuccess) {
                toastr.success('Saved successfully.');
                $.get('/ApplicationManagement/RiskAssessment/Index', { orgId: $("#OrgId").val(), CategoryId: $("#CategoryId").val(), QuestionnaireID: $("#QuestionnaireID").val(), EnablerName: $("#CategoryName").val() }, (res) => $('#ajaxresult').html(res))
            } else {
                toastr.error('Something went wrong!');
            }
        })
    }
    function fn_openPopup(input, id) {
        $("#Observation").val(input);
        $('#modaltext').text(id > 0 ? 'Recommendation' : 'Observation');
        $("#ObservationTextBox").modal("show");
    }
</script>